	TITLE	"TRIVIA -- DEMO PROGRAM"

	INSERT	"SWELL"
	INSERT	"MACROS"

	SEXTERN	.OBJBASE				;EXEC
	SEXTERN	.KEYPAD					;KEYPAD
	EXTERN	FILLRAM,INITOBJS,GETVEL,PACKV,INLMES		;ESUBS
	EXTERN	FLBTAB					;BTAB
	EXTERN	DETSTPOB				;OBJECT
	EXTERN	BALLGAME				;BSOUND
	EXTERN  ONTRAIL					;TRAIL
	EXTERN	OUTSTR					;IO
	EXTERN	BUZZA					;SLIB

	MAN=.OBJBASE+8		;MAN OBJECT
	BEES=.OBJBASE+16	;BEES OBJECT

ASECT &50000
	BIDECLE	MOVGRAM			;MOVING PICTURE BASE
	BIDECLE	CNTERS			;PROCESS TABLE
	BIDECLE	RESET			;RESET ROUTINE
	BIDECLE	BAKGRAM			;BACKGROUND PICTURE BASE
	BIDECLE	BLIST			;BACKGROUND LIST
	BIDECLE	TNAME			;TRIVIA NAME
	DECLE	1			;KEYPAD CLICKS
	DECLE	0			;NO EXTENDED BORDER
	DECLE	0			;NORMAL MODE
	DECLE	CH.GREEN,0,0,0		;COLOR STACK
	DECLE	CH.RED			;BORDER COLOR
	DECLE	0			;NOTHING
	DECLE	62*8			;RESERVE SPACE IN GRAM FOR MAN
	DECLE	60*8			;BEES

CNTERS:	PROCESS	CTRL,2		;CONTROL FUNCTIONS
	PROCESS	0,0		;TERMINATE LIST

BLIST:	DECLE	..NUMPCT
	.NUMPCT.==0
	GM.CHAR	"A"-" ",YMIR!GRO,1
	..NUMPCT=.NUMPCT.

TNAME:	DECLE	78,"KILLER BEES",0	;YEAR AND GAME
	TITLE	"RESET ROUTINE"

RESET:	BEGIN
	MOV	#BACKTAB,R4	;BACKGROUND TABLE
	MOV	#240,R0		;COUNT
	CLR	R1		;FILL WITH ZERO
	CALL	FILLRAM		;FILL RAM
	MOV	#MAN,R2		;DATA BASE OF OBJECT
	MOV	#MANRAM,R1	;PROTOTYPE DATA BASE
	MOV	#2,R0		;NUMBER OF OBJECTS
	CALL	INITOBJS	;INITIALIZE HIM
	RETURN			;READY TO GO
	TITLE	"DO CONTROL OF GUY"

CTRL:	BEGIN
	MOV	MAN+.OBJX,R0	;R0 IS X POSITION
	SWAP	R0		;GET IN LOW HALF
	MOV	MAN+.OBJY,R1	;R1 IS Y POSITION
	SWAP	R1		;GET IN HIGH HALF
	CALL	PACKV		;PACK POSITION
	MOV	R0,R2		;R2 IS MAN'S POSITION
	MOV	#BEES,R1		;R1 IS BEES OBJECT BASE
	MOV	#10,R3		;R3 IS SPEED OF BEES
	CALL	ONTRAIL		;SET LOOSE BEES
	MOV	MAN+.OBJSEQ,R3	;CLEAR SPEED OF SEQUENCING
	AND	#NOT $03F0,R3	; ..
	MOV	.KEYPAD,R1	;WHERE DOES HE WANT TO GO?
	MOV	R1,R0		;CHECK STATUS BITS
	AND	#$C0,R0		; ..
	BNZ	STPGUY		;STOP MOTION IF WHEEL NOT PUSHED
	XOR	#$03F0,R3	;MOVING, SO HE SEQUENCES AT MAX RATE
	MOV	R3,MAN+.OBJSEQ	; ..
	MOV	#20,R0		;SPEED AT WHICH HE RUNS
	CALL	GETVEL		;FIGURE VELOCITY
	MOV	R0,MAN+.OBJMOT	;AND STORE IT
	MOV	MAN+.OBJSTAT,R1	;GET STATUS BITS
	AND	#NOT ST.XMIRROR,R1	;NOT MIRRORED IN X
	TST	R0		;FACING PROPERLY?
	BPL	CTRL1		;GO IF YES
	XOR	#ST.XMIRROR,R1	;NO, MUST MIRROR IN X
CTRL1:	MOV	R1,MAN+.OBJSTAT	;AND RESTORE STATUS
	RETURN			;AND RETURN


STPGUY:	MOV	R3,MAN+.OBJSEQ	;STOP SEQUENCING
	CLR	R0		;AND MOTION
	MOV	R0,MAN+.OBJMOT	; ..
	RETURN			;AND RETURN
	TITLE	"MAN STARTS TO RUN OFF SCREEN EDGE"

CENTER:	BEGIN
REPEAT 0
	MOV	#FOREX/2,R0	;POSITION IN MIDDLE OF SCREEN
	SWAP	R0		; ..
	MOV	R0,MAN+.OBJX	; ..
	MOV	#FOREY/2,R0	;SAME FOR Y
	SWAP	R0		; ..
	MOV	R0,MAN+.OBJY	; ..
ENDR
	RETURN			;AND RETURN


HITBEES:BEGIN
	MOV	@R1,R0		;STATUS OF MAN
	AND	#NOT ST.RED,R0	;SET RED ALSO
	XOR	#ST.RED,R0	; ..
	MOV	R0,@R1		;AND RESTORE
	ADD	#.OBJTIM,R1	;TIME WHEN DONE
	MOV	#60,R0		;1 SECOND
	MOV	R0,@R1		;STORE
	MOV	#CH.BLACK,R3	;WRITE "OUCH!"
	MOV	#BACKTAB+86,R4
	CALL 	INLMES
	DECLE	"OUCH!",0
	MOV	#5,R0		;1/2 SECOND
;	CALL	BUZZA		;BUZZ
	RETURN			;AND QUIT


HITDONE:BEGIN			;TIMER EXPIRES
	MOV	@R1,R0		;CLEAR RED
	AND	#NOT ST.RED,R0	; ..
	MOV	R0,@R1		;AND RESTORE
	MOV	#CH.GREEN,R3
	MOV	#BACKTAB+86,R4
	CALL	INLMES
	DECLE	"      ",0
	RETURN			;AND RETURN

	TITLE	"PROTOTYPE DATA BLOCK"

MANRAM:	BIDECLE	ST.VISIBLE!ST.INTERACT!ST.YRES!ST.BLUE		;BLUE MAN
	BIDECLE	MANROM			;ROM DATA BLOCK
	POSITION FOREX/2		;INITIALIZE IN CENTER
	POSITION FOREY/2		; ..
	DECLE	0,0			;NO INITIAL SPEED
	SEQRATE	0			;DOES NOT SEQUENCE INITIALLY
	BIDECLE	0			;NO INITIAL TIME-OUT
	BIDECLE	0			;NO EXTRA WORD

BEESRAM:BIDECLE	ST.VISIBLE!ST.INTERACT!ST.YRES!ST.RED!ST.GREEN	;BEES
	BIDECLE	BEESROM			;ROM DATA BLOCK
	POSITION FOREX-16		;INITIALIZE TO RIGHT
	POSITION 16			;AT TOP
	DECLE	0,0			;NO SPEED
	SEQRATE	30			;SEQUENCE
	BIDECLE	0			;NO TIME OUT
	BIDECLE	0			;NO EXTRA WORD

MANROM:	OFF	OF.CENTER,CENTER	;ROUTINE TO CALL WHEN GUY STEPS OFF
	BIDECLE	HITDONE			;TIME OUT
	SEQDEF	MANPCT,8		;STARTS FROM FIRST PICTURE IN GRAM
	INTDEF	0,1			;CAN HIT BEES
	INTERACT 2,HITBEES		;WHERE TO GO WHEN HIT

BEESROM:OFF	OF.CENTER,0		;WILL NOT LEAVE SCREEN
	BIDECLE	0			;NO TIME OUT
	SEQDEF	BEESPCT,3		;3 PICTURES
	INTDEF	0,0			;DOESN'T REGISTER COLLISION
	TITLE	"RUNNING MAN PICTURES"
 
MOVGRAM:
	MANPCT=(*-MOVGRAM)/8
	DECLE	NOT$F3,NOT$F1,NOT$FF,NOT$F3,NOT$F3,NOT$F3,NOT$F3,NOT$F1,NOT$F3,NOT$F3,NOT$F3,NOT$C3,NOT$D7,NOT$D7,NOT$F7,NOT$F3
	DECLE	NOT$F9,NOT$F8,NOT$FF,NOT$F3,NOT$E3,NOT$E3,NOT$E1,NOT$E7,NOT$E3,NOT$C1,NOT$DD,NOT$D1,NOT$D7,NOT$DF,NOT$DF,NOT$EF
	DECLE	NOT$F9,NOT$F8,NOT$FF,NOT$E3,NOT$C3,NOT$D1,NOT$D3,NOT$FF,NOT$E3,NOT$C0,NOT$DE,NOT$D8,NOT$DB,NOT$BB,NOT$BF,NOT$BF
	DECLE	NOT$F3,NOT$F1,NOT$FF,NOT$87,NOT$A7,NOT$A0,NOT$E7,NOT$FF,NOT$E7,NOT$C0,NOT$DE,NOT$9D,NOT$BD,NOT$3F,NOT$7F,NOT$7F
	DECLE	NOT$F3,NOT$F1,NOT$8F,NOT$A7,NOT$A0,NOT$E7,NOT$E7,NOT$FF,NOT$E7,NOT$C0,NOT$DE,NOT$9E,NOT$BE,NOT$3F,NOT$7F,NOT$FF
	DECLE	NOT$F3,NOT$F1,NOT$FF,NOT$87,NOT$A7,NOT$A0,NOT$E7,NOT$FF,NOT$E7,NOT$C3,NOT$DB,NOT$99,NOT$3D,NOT$7D,NOT$FC,NOT$FF
	DECLE	NOT$F9,NOT$F8,NOT$FF,NOT$E3,NOT$C3,NOT$D1,NOT$D3,NOT$FF,NOT$C7,NOT$C3,NOT$DB,NOT$1B,NOT$7B,NOT$7B,NOT$FB,NOT$F9
	DECLE	NOT$F9,NOT$F8,NOT$FF,NOT$F3,NOT$E3,NOT$E3,NOT$E1,NOT$E7,NOT$E7,NOT$E7,NOT$E7,NOT$87,NOT$B7,NOT$B7,NOT$F7,NOT$F3

	BEESPCT=(*-MOVGRAM)/8
	DECLE	$08,$24,$00,$50,$25,$90,$2A,$15,$A0,$4A,$10,$44,$00,$14,$00,$00
	DECLE	$00,$00,$14,$00,$44,$10,$4A,$A0,$15,$2A,$90,$25,$50,$00,$24,$08
	DECLE	$08,$10,$04,$20,$48,$02,$51,$A4,$12,$80,$54,$22,$08,$00,$24,$00


BAKGRAM:DECLE	$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF		;FULL PICTURE
