        TITLE   "TRIVIA -- DEMO PROGRAM"

        INSERT  "SWELL"
        INSERT  "MACROS"

        SEXTERN .OBJBASE                                ;EXEC
        SEXTERN .KEYPAD                                 ;KEYPAD
        EXTERN  FILLRAM,INITOBJS,GETVEL                 ;ESUBS
        EXTERN  DETSTPOB                                ;OBJECT
        EXTERN  INLMES                                  ;IO
        EXTERN  PIANO                                   ;SOUND

        MAN=.OBJBASE+8          ;MAN OBJECT
        MINE=.OBJBASE+16        ;MINE OBJECT

PSECT
        BIDECLE MOVGRAM                 ;MOVING PICTURE BASE
        BIDECLE CNTERS                  ;PROCESS TABLE
        BIDECLE RESET                   ;RESET ROUTINE
        BIDECLE BAKGRAM                 ;BACKGROUND PICTURE BASE
        BIDECLE BLIST                   ;BACKGROUND LIST
        BIDECLE TNAME                   ;TRIVIA NAME
        DECLE   %10000001               ;KEYPAD CLICKS
        DECLE   0                       ;NO EXTENDED BORDER
        DECLE   0                       ;NORMAL MODE
        DECLE   CH.GREEN,0,0,0          ;COLOR STACK
        DECLE   CH.RED                  ;BORDER COLOR
        DECLE   0                       ;NOTHING
        DECLE   62*8                    ;RESERVE SPACE IN GRAM FOR MAN
        DECLE   61*8                    ;MINE

CNTERS: PROCESS CTRL,2          ;CONTROL FUNCTIONS
        PROCESS 0,0             ;TERMINATE LIST

BLIST:  DECLE   ..NUMPCT
        .NUMPCT.==0
        GM.CHAR "A"-" ",YMIR!GRO,1
        ..NUMPCT=.NUMPCT.


        TITLE   "SPECIAL TITLE"

TNAME:  DECLE   78,"KILLER BEES",0      ;YEAR AND GAME

DOTITL: BEGIN
        MOV     #CH.WHITE,R3    ;WRITE IN WHITE
        MOV     #BACKTAB+3*BACKX+1,R4   ;ON SCREEN
        CALL    INLMES          ;WRITE MESSAGE
          DECLE " TALKIN HORSE INC ",0
        RETURN


        TITLE   "RESET ROUTINE"

RESET:  BEGIN
        MOV     #BACKTAB,R4     ;BACKGROUND TABLE
        MOV     #240,R0         ;COUNT
        CLR     R1              ;FILL WITH ZERO
        CALL    FILLRAM         ;FILL RAM
        MOV     #MAN,R2         ;DATABASE OF OBJECT
        MOV     #MANRAM,R1      ;PROTOTYPE DATABASE
        MOV     #2,R0           ;NUMBER OF OBJECTS
        CALL    INITOBJS        ;INITIALIZE HIM
        RETURN                  ;READY TO GO


        TITLE   "DO CONTROL OF GUY"

CTRL:   BEGIN
        MOV     MAN+.OBJSEQ,R3  ;CLEAR SPEED OF SEQUENCING
        AND     #NOT $03F0,R3   ; ..
        MOV     .KEYPAD,R1      ;WHERE DOES HE WANT TO GO?
        MOV     R1,R0           ;CHECK STATUS BITS
        AND     #$C0,R0         ; ..
        BNZ     STPGUY          ;STOP MOTION IF WHEEL NOT PUSHED
        XOR     #$03F0,R3       ;MOVING, SO HE SEQUENCES AT MAX RATE
        MOV     R3,MAN+.OBJSEQ  ; ..
        MOV     #12,R0          ;SPEED AT WHICH HE RUNS
        CALL    GETVEL          ;FIGURE VELOCITY
        MOV     R0,MAN+.OBJMOT  ;AND STORE IT
        MOV     MAN+.OBJSTAT,R1 ;GET STATUS BITS
        AND     #NOT ST.XMIRROR,R1      ;NOT MIRRORED IN X
        TST     R0              ;FACING PROPERLY?
        BPL     CTRL1           ;GO IF YES
        XOR     #ST.XMIRROR,R1  ;NO, MUST MIRROR IN X
CTRL1:  MOV     R1,MAN+.OBJSTAT ;AND RESTORE STATUS
        RETURN                  ;AND RETURN


STPGUY: MOV     R3,MAN+.OBJSEQ  ;STOP SEQUENCING
        CLR     R0              ;AND MOTION
        MOV     R0,MAN+.OBJMOT  ; ..
        RETURN                  ;AND RETURN


        TITLE   "MAN STARTS TO RUN OFF SCREEN EDGE"

CENTER: BEGIN
REPEAT 0
        MOV     #FOREX/2,R0     ;POSITION IN MIDDLE OF SCREEN
        SWAP    R0              ; ..
        MOV     R0,MAN+.OBJX    ; ..
        MOV     #FOREY/2,R0     ;SAME FOR Y
        SWAP    R0              ; ..
        MOV     R0,MAN+.OBJY    ; ..
ENDR
        SLL     R2,1            ;OFFSET
        ADD     R2,R7           ;DISPATCH
        BRA     OFFRIT
        BRA     OFFLFT
        BRA     OFFBOT
;       BRA     OFFTOP
OFFTOP: MOV     #FOREY,R0
        SWAP    R0
        INC     R7
OFFBOT: CLR     R0
        MOV     R0,MAN+.OBJY
        RETURN                  ;AND RETURN
OFFLFT: MOV     #FOREX,R0
        SWAP    R0
        INC     R7
OFFRIT: CLR     R0
        MOV     R0,MAN+.OBJX
        RETURN


HITMINE:BEGIN
        MOV     #$0808,R4       ;HOW CLOSE WE CAN GET TO MINE
;       CALL    DETSTPOB        ;STOP COLLISION
        MOV     @R1,R0          ;STATUS OF MAN
        AND     #NOT ST.RED,R0  ;SET RED ALSO
        XOR     #ST.RED,R0      ; ..
        MOV     R0,@R1          ;AND RESTORE
        ADD     #.OBJTIM,R1     ;TIME WHEN DONE
        MOV     #120,R0         ;2 SECONDS
        MOV     R0,@R1          ;STORE
        RETURN                  ;AND QUIT


HITDONE:BEGIN                   ;TIMER EXPIRES
        MOV     @R1,R0          ;CLEAR READ
        AND     #NOT ST.RED,R0  ; ..
        MOV     R0,@R1          ;AND RESTORE
        RETURN                  ;AND RETURN


        TITLE   "PROTOTYPE DATA BLOCK"

MANRAM: BIDECLE ST.VISIBLE!ST.INTERACT!ST.YRES!ST.BLUE          ;BLUE MAN
        BIDECLE MANROM                  ;ROM DATA BLOCK
        POSITION FOREX/2                ;INITIALIZE IN CENTER
        POSITION FOREY/2                ; ..
        DECLE   0,0                     ;NO INITIAL SPEED
        SEQRATE 0                       ;DOES NOT SEQUENCE INITIALLY
        BIDECLE 0                       ;NO INITIAL TIME-OUT
        BIDECLE 0                       ;NO EXTRA WORD

MINERAM:BIDECLE ST.VISIBLE!ST.INTERACT!ST.YFULL!ST.RED  ;MINE
        BIDECLE MINEROM                 ;ROM DATA BLOCK
        POSITION FOREX-30               ;INITIALIZE TO RIGHT
        POSITION FOREY/2                ;IN CENTER
        DECLE   0,0                     ;NO SPEED
        SEQRATE 0                       ;NO SEQUENCE
        BIDECLE 0                       ;NO TIME OUT
        BIDECLE 0                       ;NO EXTRA WORD

MANROM: OFF     OF.SCREEN,CENTER        ;ROUTINE TO CALL WHEN GUY STEPS OFF
        BIDECLE HITDONE                 ;TIME OUT
        SEQDEF  MANPCT,8                ;STARTS FROM FIRST PICTURE IN GRAM
        INTDEF  0,1                     ;CAN HIT MINE
        INTERACT 2,HITMINE              ;WHERE TO GO WHEN HIT

MINEROM:OFF     OF.CENTER,0             ;WILL NOT LEAVE SCREEN
        BIDECLE 0                       ;NO TIME OUT
        SEQDEF  MINEPCT,1               ;ONLY 1 PICTURE
        INTDEF  0,0                     ;DOESN'T REGISTER COLLISION


        TITLE   "RUNNING MAN PICTURES"
 
MOVGRAM:
        MANPCT=(*-MOVGRAM)/8
        DECLE   NOT$F3,NOT$F1,NOT$FF,NOT$F3,NOT$F3,NOT$F3,NOT$F3,NOT$F1,NOT$F3,NOT$F3,NOT$F3,NOT$C3,NOT$D7,NOT$D7,NOT$F7,NOT$F3
        DECLE   NOT$F9,NOT$F8,NOT$FF,NOT$F3,NOT$E3,NOT$E3,NOT$E1,NOT$E7,NOT$E3,NOT$C1,NOT$DD,NOT$D1,NOT$D7,NOT$DF,NOT$DF,NOT$EF
        DECLE   NOT$F9,NOT$F8,NOT$FF,NOT$E3,NOT$C3,NOT$D1,NOT$D3,NOT$FF,NOT$E3,NOT$C0,NOT$DE,NOT$D8,NOT$DB,NOT$BB,NOT$BF,NOT$BF
        DECLE   NOT$F3,NOT$F1,NOT$FF,NOT$87,NOT$A7,NOT$A0,NOT$E7,NOT$FF,NOT$E7,NOT$C0,NOT$DE,NOT$9D,NOT$BD,NOT$3F,NOT$7F,NOT$7F
        DECLE   NOT$F3,NOT$F1,NOT$8F,NOT$A7,NOT$A0,NOT$E7,NOT$E7,NOT$FF,NOT$E7,NOT$C0,NOT$DE,NOT$9E,NOT$BE,NOT$3F,NOT$7F,NOT$FF
        DECLE   NOT$F3,NOT$F1,NOT$FF,NOT$87,NOT$A7,NOT$A0,NOT$E7,NOT$FF,NOT$E7,NOT$C3,NOT$DB,NOT$99,NOT$3D,NOT$7D,NOT$FC,NOT$FF
        DECLE   NOT$F9,NOT$F8,NOT$FF,NOT$E3,NOT$C3,NOT$D1,NOT$D3,NOT$FF,NOT$C7,NOT$C3,NOT$DB,NOT$1B,NOT$7B,NOT$7B,NOT$FB,NOT$F9
        DECLE   NOT$F9,NOT$F8,NOT$FF,NOT$F3,NOT$E3,NOT$E3,NOT$E1,NOT$E7,NOT$E7,NOT$E7,NOT$E7,NOT$87,NOT$B7,NOT$B7,NOT$F7,NOT$F3

        MINEPCT=(*-MOVGRAM)/8
        DECLE   $AA,$55,$AA,$55,$AA,$55,$AA,$55


BAKGRAM:DECLE   $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF         ;FULL PICTURE

